--- status: DRAFT
--- author(s): blasiak, kummini
--- notes: 

document { 
     Key => minors,
     Headline => "ideal generated by minors",
--      Usage => "",
--      Inputs => {
-- 	  },
--      Outputs => {
-- 	  },
--      Consequences => {
-- 	  },     
--      "description",
--      EXAMPLE {
-- 	  },
--      Caveat => {},
     SeeAlso => {"exteriorPower", "det"}
     }
document { 
     Key => (minors,ZZ,Matrix),
     Headline => "",
     Usage => "minors(n,M)",
     Inputs => {
		   "n" => ZZ => "order of the minor",
		   "M" => Matrix => "a map between free modules"
	  },
	Outputs => {
		   {"the ideal generated by the ", TT "n", " by ", TT "n", " minors
		   of the matrix ", TT "M", "."}
	},
	"Minors are generated in the same order as that used by ", 
	TO (subsets,ZZ,ZZ), ".",
     EXAMPLE {
	  "R = ZZ[a..f];",
	  "M = matrix{{a,b,c},{d,e,f}}",
	  "minors(2,M)",
	  "minors(2,M,Limit=>1)",
	  },

     }
document { 
     Key => [minors, Limit],
     Headline => "the maximum number of minors to compute",
     Usage => "minors(...,Limit => r)",
     Inputs => {
 	  "r" => ZZ
	  },
	"the computation stops after ", TT "r", " minors are obtained. For an
	example, see ", TO (minors,ZZ,Matrix), "."
     }
 -- doc7.m2:1778:     Key => minors,
 -- doc7.m2:1783:     Key => (minors,ZZ,Matrix),
 -- doc7.m2:1834:     Key => [minors,First],
 -- doc7.m2:1853:     Key => [minors,Limit],
 -- overviewB.m2:1047:     Key => "determinants and minors",

-- document {
--      Key => [minors,Limit],
--      Inputs => {
-- 	  },
--      Consequences => {
-- 	  {
-- 	  }
--      }
-- 
-- document {
--      Key => (minors,ZZ,Matrix),
--      Headline => "ideal generated by minors",
--      Usage => "minors(p,m)",
--      Inputs => {
-- 	  "p",
-- 	  "m" => 
-- 	  },
--      ,
--      "Minors are generated in the same order as that used by ", TO (subsets,ZZ,ZZ), ".  The
--      order is {{0,1},{0,1}}, {{0,2},{0,1}}, {{1,2},{0,1}}, and so on.",
--      EXAMPLE {
-- 	  "R = ZZ[vars(0..11)];",
-- 	  "M = genericMatrix(R,a,4,3)",
-- 	  "transpose generators minors(2,M)",
-- 	  "subsets(4,2)"
-- 	  },
--      SUBSECTION "Programming hint",
--      "If the ", TO2{ [minors,First], "First"}, " option is not given, the minors are stashed
--      in the matrix and are obtainable with ", TT "m.cache#MinorsComputation{p}", ".  The class of
--      this stashed object is ", TO "MinorsComputation", "."
--      }
